#include "fx.h"

struct PrjData
{
	FXString folder;
};

class CVSStatus
{
public:
	FXString fname;
	FXString directory;
	FXString status;
	FXString workRev;
	FXString revDate;
	FXString repRev;
	FXString repFile;
	FXString stickTag;
	FXString stickDate;
	FXString stickOpt;

	void clear() {
		fname.clear();
		directory.clear();
		status.clear();
		workRev.clear();
		revDate.clear();
		repRev.clear();
		repFile.clear();
		stickTag.clear();
		stickDate.clear();
		stickOpt.clear();
	}
};

class MainWindow : public FXMainWindow {
	FXDECLARE(MainWindow)
		
protected:
	// Member data
	PrjData *prjdata;
	FXMenuPane	*filemenu;
	FXMenuPane	*viewmenu;
	FXMenuPane	*helpmenu;
	FXGIFIcon *folderOpen;
	FXGIFIcon *folderClosed;
	FXGIFIcon *newIcon;
	FXGIFIcon *saveIcon;
	FXGIFIcon *saveasIcon;
	FXGIFIcon *openIcon;
	FXGIFIcon *deleteIcon;
	FXGIFIcon *logIcon;
	FXGIFIcon *statusIcon;
	FXGIFIcon *diffIcon;
	FXGIFIcon *watchIcon;
	FXGIFIcon *tagIcon;
	FXGIFIcon *branchIcon;
	FXTreeList *m_folders;
	FXText *m_cmdbox;
	FXIconList *m_files;
	int fdout[2];


protected:
	MainWindow(){}
	FXString RunCmd(FXString cmd);
	void ScanDir(char *directory);
	bool ParseCVSStatus(FXString ret, CVSStatus *cvsstat);
	void UpdateStatus(int item);
	void RefreshFiles(FXTreeItem *item); 
	void LoadProjects();
	void ParseFileEntry(FXString entry, CVSStatus *cvsstat);

public:
	long onUpdatePrj(FXObject *sender, FXSelector,void*);
	long onUpdate(FXObject *sender, FXSelector,void*);
	long onCmdAbout(FXObject*,FXSelector,void*);
	long onCmdStatus(FXObject*,FXSelector,void*);
	long onCmdTrigger(FXObject*,FXSelector,void*);
	long onCmdClkTree(FXObject*, FXSelector, void *ptr);
	long onCmdLog(FXObject*,FXSelector,void*);
	long onCmdDiff(FXObject*,FXSelector,void*);
	long onCmdCommit(FXObject*,FXSelector,void*);
	long onCmdWatch(FXObject*,FXSelector,void*);
	long onCmdTag(FXObject*,FXSelector,void*);
	long onCmdAdd(FXObject*,FXSelector,void*);
	long onCmdDelete(FXObject*,FXSelector,void*);
	long onCmdNewPrj(FXObject*,FXSelector,void*);
	long onCmdBranch(FXObject*,FXSelector,void*);

public:
	enum{
		ID_FOLDER_TREE=FXMainWindow::ID_LAST,
		ID_ADD,
		ID_DELETE,
		ID_UPDATE,
		ID_TRIGGER,
		ID_STATUS,
		ID_LOG,
		ID_DIFF,
		ID_COMMIT,
		ID_TAG,
		ID_BRANCH,
		ID_WATCH,
		ID_IMPORT,
		ID_CHECKOUT,
		ID_RELEASE,
		ID_PRJ_NEW,
		ID_PRJ_EDIT,
		ID_PRJ_DELETE,
		ID_FILE_LIST,
		ID_ABOUT,
		ID_LAST
	};

public:
	MainWindow(FXApp* a);
	virtual void create();
};

